var colcnt = 22;
var oLightDeviceArray = [];

function initValues() {
	initCaches();

	for ( var i = 0; i < deviceCache.length; i++) {
		var oDeviceObject = deviceCache[i];
		if (oDeviceObject.functionID & 0xf000) {
			if (oDeviceObject.outputMode == 22)
				oLightDeviceArray.push(oDeviceObject);
		} else if (oDeviceObject.buttonActiveGroup == 1) {
			if (oDeviceObject.outputMode == 22)
				oLightDeviceArray.push(oDeviceObject);
		}
	}

	var sString = '';
	for ( var iIndex = 0; iIndex < nameCache.length; iIndex++) {
		var fShouldBeInsert = false;
		if (nameCache[iIndex].ZoneID == 0)
			fShouldBeInsert = true;
		else {
			for ( var jIndex = 0; jIndex < oLightDeviceArray.length; jIndex++) {
				if (nameCache[iIndex].ZoneID == oLightDeviceArray[jIndex].ZoneID)
					fShouldBeInsert = true;
			}
		}
		if (fShouldBeInsert)
			sString += '<option value="' + nameCache[iIndex].ZoneID + '">'
					+ nameCache[iIndex].name + '</option>';
	}
	if (sString == '') {
		document.getElementById('zoneSelector').innerHTML = '<option selected>keine Ger&aum;te vorhanden</option>'
		document.getElementById('zoneSelector').disabled = 'disabled';
	} else {
		document.getElementById('zoneSelector').innerHTML = '<option value="-1">bitte w&auml;hlen</option>'
				+ sString;
		document.getElementById('zoneSelector').disabled = '';
	}
	document.getElementById('deviceSelector').innerHTML = '<option value="-1">bitte erst Raum w&auml;hlen</option>';
	document.getElementById('deviceSelector').disabled = 'disabled';

	if (db_cnt == 0) {
		offlinemode = 1;
		LoadDB(0, 0);
	} else {
		for ( var entry_no = 0; entry_no < db_cnt; entry_no++) {
			db_data[entry_no][0].replace(/,/, ";");
			for ( var i = 1; i < colcnt; i++) {
				db_data[entry_no][i].replace(/,/, ".");
			}
		}
		SaveDB(0, -20);

		initLeuchtMittel();		
	}
	graphInit();
}

function selectingZone() {
	var selectedValue = document.getElementById('zoneSelector').value;
	var sString = '';
	if (selectedValue != "-1") {
		for ( var iIndex = 0; iIndex < oLightDeviceArray.length; iIndex++) {
			var oDeviceObject = oLightDeviceArray[iIndex];
			if (("" + oDeviceObject.ZoneID == selectedValue)
					|| (selectedValue == "0")) {
				sString += '<option value="' + oDeviceObject.dSID + '">'
						+ oDeviceObject.name + ' - dSID: ' + oDeviceObject.dSID
						+ '</option>';
			}
		}
	}
	if (sString == '') {
		document.getElementById('deviceSelector').innerHTML = '<option value="-1">keine Ger&auml;te vorhanden</option>';
		document.getElementById('deviceSelector').disabled = 'disabled';
	} else {
		document.getElementById('deviceSelector').disabled = '';
		document.getElementById('deviceSelector').innerHTML = '<option value="-1">bitte w&auml;hlen</option>'
				+ sString;
	}
}

function selectingDevice() {
	if (document.getElementById('deviceSelector').value != -1) {
		var oSelectedDevice = getDevice(document
				.getElementById('deviceSelector').value);
		document.getElementById('deviceName').innerHTML = oSelectedDevice.name;
		document.getElementById('deviceDSID').innerHTML = oSelectedDevice.dSID;
		if (oSelectedDevice.productID == 200)
			document.getElementById('deviceHW').innerHTML = 'GE-KM 200';
		else if (oSelectedDevice.productID == 1234)
			document.getElementById('deviceHW').innerHTML = 'GE-TKM 210';
		else if (oSelectedDevice.productID == 3272)
			document.getElementById('deviceHW').innerHTML = 'SW-KL 200';

	} else {
		document.getElementById('deviceName').innerHTML = '<span style="color:#888888;">- nicht gew&auml;hlt -</span>';
		document.getElementById('deviceDSID').innerHTML = '<span style="color:#888888;">- nicht gew&auml;hlt -</span>';
		document.getElementById('deviceHW').innerHTML = '<span style="color:#888888;">- nicht gew&auml;hlt -</span>';
	}
}
function XHR(u, f, v) {
	var x = this.ActiveXObject;
	x = new (x ? x : XMLHttpRequest)('Microsoft.XMLHTTP');
	x.open('GET', u, 1);
	x.onreadystatechange = function() {
		x.readyState > 3 ? x.status == 200 ? f(
				eval("(" + x.responseText + ")"), v) : 0 : 0
	};
	x.send(null)
}

function LoadDB(response, state) {
	var s = "";

	if (state == 0) {
		// prfe, ob db vorhanden
		setMessage("Prfe Offlinedatenbank", false);
		XHR("/json/property/query?query=/scripts/dimmer/db(*)", LoadDB, 1);
	} else if (state == 1) {
		if ((response.ok == false)
				|| (typeof response.result.db == 'undefined')
				|| (response.result.db.length < 1)
				|| (typeof response.result.db[0].cnt == 'undefined')
				|| (response.result.db[0].cnt <= 0)) {
			// Offlinedatenbank nicht vorhanden
			setMessage(
					"Offlinedatenbank konnte nicht gefunden werden. Bitte Internetverbindung am Computer herstellen und Add-On erneut starten.",
					true);
		} else {
			// db vorhanden
			db_cnt = parseInt(response.result.db[0].cnt);
			var ts = new Date(parseInt(response.result.db[0].ts));
			var tsu = new Date(parseInt(response.result.db[0].update * 1000));
			setMessage(
					"Offlinedatenbank erfolgreich eingelesen, zuletzt aktualisiert am "
							+ ts.getDate() + "." + (ts.getMonth() + 1) + "."
							+ ts.getFullYear() + ", Datenbankstand vom "
							+ tsu.getDate() + "." + (tsu.getMonth() + 1) + "."
							+ tsu.getFullYear(), false);

			db_data = new Array();
			for ( var i = 0; i < db_cnt; i++) {
				db_data[i] = response.result.db[0][i].split(",");
			}
			initLeuchtMittel();
		}
	}
}

function initLeuchtMittel() {
	var sString = "";
	for ( var i = 0; i < db_cnt; i++) {
		sString = sString + "<option value=\"" + i + "\"";
		if (i == 0)
			sString = sString + " selected";
		sString = sString + ">" + db_data[i][0] + "</option>";
	}
	document.getElementById('curveSelector').innerHTML = sString;
}

function setMessage(sText, fDisabled) {
	document.getElementById('stateDisplay').innerHTML = sText;
	if (fDisabled == true) {
		document.getElementById('curveSelector').disabled = 'disabled';
		document.getElementById('zoneSelector').disabled = 'disabled';
		document.getElementById('deviceSelector').disabled = 'disabled';
	} else {
		document.getElementById('curveSelector').disabled = '';
		document.getElementById('zoneSelector').disabled = '';
		document.getElementById('deviceSelector').disabled = '';
	}
}

function changeCurve()
{

	for (var i=1; i<18; i++) {
	      update(i-1,translate(i-1,db_data[document.getElementById('curveSelector').value][i])[1]);
	   }
	  drawPath();
}

function startCurve() {

}

function SaveDB(response, state) {
	var s = "";

	if (state == -20) {
		// prfe, ob db vorhanden
		setMessage("Prfe Offlinedatenbank", false);
		XHR("/json/property/getString?path=/scripts/dimmer/db/cnt", SaveDB, -19);
	} else if (state == -19) {
		if ((response.ok == false) || (response.result.value <= 0)) {
			// db muss neu gespeichert werden
			SaveDB(0, -10);
		} else {
			// prfe db version
			XHR("/json/property/getString?path=/scripts/dimmer/db/update",
					SaveDB, -18);
		}
	} else if (state == -18) {
		if ((response.ok == false) || (response.result.value != db_update)) {
			// db muss neu gespeichert werden
			SaveDB(0, -10);
		} else {
			// db aktuell, lese Speicherdatum
			XHR("/json/property/getString?path=/scripts/dimmer/db/ts", SaveDB,
					-17);
		}
	} else if (state == -17) {
		if ((response.ok == false) || (response.result.value <= 0)) {
			// db muss neu gespeichert werden
			SaveDB(0, -10);
		} else {
			var ts = new Date(parseInt(response.result.value));
			var tsu = new Date(parseInt(db_update * 1000));
			setMessage("Offlinedatenbank bereits aktuell, zuletzt aktualisert am "
					+ ts.getDate()
					+ "."
					+ (ts.getMonth() + 1)
					+ "."
					+ ts.getFullYear()
					+ ", Datenbankstand vom "
					+ tsu.getDate()
					+ "."
					+ (tsu.getMonth() + 1)
					+ "."
					+ tsu.getFullYear());
		}
	} else if (state == -10) {
		// delete DB
		setMessage("Lsche Offlinedatenbank");
		XHR("/json/property/remove?path=/scripts/dimmer/db", SaveDB, 0);
	} else if (state == -8) {
		// save timestamp
		setMessage("Datenbankaktualisierung wird abgeschlossen");
		XHR("/json/property/setString?path=/scripts/dimmer/db/update&value="
				+ db_update, SaveDB, -7);
	} else if (state == -7) {
		// save timestamp
		XHR(
				"/json/property/setFlag?path=/scripts/dimmer/db/update&flag=ARCHIVE&value=true",
				SaveDB, -6);
	} else if (state == -6) {
		// save timestamp
		var ts = new Date();
		XHR("/json/property/setString?path=/scripts/dimmer/db/ts&value="
				+ ts.getTime(), SaveDB, -5);
	} else if (state == -5) {
		// save timestamp
		XHR(
				"/json/property/setFlag?path=/scripts/dimmer/db/ts&flag=ARCHIVE&value=true",
				SaveDB, -4);
	} else if (state == -4) {
		// save cnt
		XHR("/json/property/setString?path=/scripts/dimmer/db/cnt&value="
				+ db_cnt, SaveDB, -3);
	} else if (state == -3) {
		// save cnt
		XHR(
				"/json/property/setFlag?path=/scripts/dimmer/db/cnt&flag=ARCHIVE&value=true",
				SaveDB, -2);
	} else if (state == -2) {
		// store DB
		XHR("/json/event/raise?name=dimmer&parameter=actions=save", SaveDB, -1);
	} else if (state == -1) {
		// fertig
		setMessage("Offlinedatenbank erfolgreich aktualisiert");
	} else if (state >= 0) {
		if (state < (db_cnt * 2)) {
			setMessage("Speichere in Offlinedatenbank " + state + " / "
					+ (db_cnt * 2));
			var entry_no = Math.floor(state / 2);
			var arch = state % 2;

			state++;

			if (arch == 0) {
				var s = db_data[entry_no][0];
				for ( var i = 1; i < colcnt; i++) {
					s = s + "," + db_data[entry_no][i];
				}
				XHR("/json/property/setString?path=/scripts/dimmer/db/"
						+ entry_no + "&value=" + escape(s), SaveDB, state);
			} else {
				XHR("/json/property/setFlag?path=/scripts/dimmer/db/"
						+ entry_no + "&flag=ARCHIVE&value=true", SaveDB, state);
			}
		} else {
			SaveDB(0, -8);
		}
	}
}

var W = 400, H = 300, r, X = [], Y = [], path, sub, blankets, buttons, changing = 0, values = [], len = 17;

for ( var i = len; i--;) {
	values.push(50);
}

function ruecktranslate(y) {
	return Math.round(((H - 10 - y) * 255) / (H - 20));
}

var update = function(i, d) {
	(d > H - 10) && (d = H - 10);
	(d < 10) && (d = 10);
	Y[i] = d;
	drawPath();
	buttons.items[i].attr({
		cy : d
	});
	blankets.items[i].attr({
		cy : d
	});
	r.safari();
	//html('v' + (i + 1), ruecktranslate(d));
};

function translate(x, y) {
	return [ 50 + (W - 60) / (values.length - 1) * x,
			(H - 10) - (((H - 20) / 255) * y) ];
}

function drawPath() {
	var p = [];
	for ( var j = 1, jj = X.length; j < jj; j++) {
		p.push(X[j], Y[j]);
	}
	p = [ "M", X[0], Y[0], "L" ].concat(p);
	var subaddon = "L" + (W - 10) + "," + (H - 10) + ",50," + (H - 10) + "z";
	path.attr({
		path : p
	});
	sub.attr({
		path : p + subaddon
	});
}

function graphInit() {
	r = Raphael("holder", W, H);
	var p = [ [ "M" ].concat(translate(0, values[0])) ], color = "hsb(30, 1, 1)", colorsub = "hsb(40, 1, 1)", w = (W - 60)
			/ values.length, isDrag = -1, start = null, unhighlight = function() {
	};
	blankets = r.set();
	buttons = r.set();
	sub = r.path().attr({
		stroke : "none",
		fill : [ 180, colorsub, colorsub ].join("-"),
		opacity : 0
	});
	path = r.path().attr({
		stroke : color,
		"stroke-width" : 2
	});
	var ii;
	for (i = 0, ii = values.length - 1; i < ii; i++) {
		var xy = translate(i, values[i]), xy1 = translate(i + 1, values[i + 1]), f;
		X[i] = xy[0];
		Y[i] = xy[1];
		(f = function(i, xy) {
			buttons.push(r.circle(xy[0], xy[1], 3).attr({
				fill : color,
				stroke : "none"
			}));
			blankets.push(r.circle(xy[0], xy[1], w / 2).attr({
				stroke : "none",
				fill : "#fff",
				opacity : 0
			}).mouseover(function() {
				if (!changing)
					return;

				if (isDrag + 1) {
					unhighlight = function() {
					};
				} else {
					buttons.items[i].animate({
						r : 10
					}, 200);
				}
			}).mouseout(function() {
				if (!changing)
					return;

				if (isDrag + 1) {
					unhighlight = function() {
						buttons.items[i].animate({
							r : 6
						}, 200);
					};
				} else {
					buttons.items[i].animate({
						r : 6
					}, 200);
				}
			}).drag(function(dx, dy) {
				if (!changing)
					return;

				var start = this.start;
				start && update(start.i, start.p + dy);
			}, function(x, y) {
				this.start = {
					i : i,
					m : y,
					p : Y[i]
				};
			}));
			blankets.items[blankets.items.length - 1].node.style.cursor = "default";
		})(i, xy);
		if (i == ii - 1) {
			f(i + 1, xy1);
		}
	}
	xy = translate(ii, values[ii]);
	X.push(xy[0]);
	Y.push(xy[1]);

	drawPath();
};

