Ext.define(
				'DSS.component.WaitForServerStepper',
				{
					extend : 'Ext.window.Window',
					eventNameStart : '',
					msgStart : '',
					msgStep : '',
					msgDelete : '',
                    msgMultiApendix : '',
					progressBar : null,
					iSubscriptID : 0,
					iMaxStep : -1,
					constructor : function(config) {
						me = this;

						config.closeAction = 'hide';
						config.modal = true;
						config.closeable = false;
						config.height = 62;
						config.width = 310;
						config.layout = 'fit';
						config.resizable = false;
						config.title = _('Please wait');
						
						if (config.msgStart!=null)
							this.msgStart= _(config.msgStart);
						else
							this.msgStart= _('Please wait, Process is starting up');
						if (config.msgStep!=null)
							this.msgStep= _(config.msgStep);
						else
							this.msgStep= _('Executing Step {stepActual} from {stepMaximal}');
						
						if (config.msgDelete != null) {
						    this.msgDelete = _(config.msgDelete);
						} else {
						    this.msgDelete = _('Please wait while device is removed');
						}
                        this.msgMultiApendix = _(' for device {currentDevice} of {maxNrOfDevice}');
						this.eventNameStart = config.eventNameStart;
						this.endCallback = config.endCallback;
						this.iSubscriptID = 0;

						this.progressBar = Ext.create('Ext.ProgressBar', {
							width : 290
						});

						Ext.apply(me, {
							items : [ {
								xtype : 'panel',
								items : [ this.progressBar ],
								bodyPadding : 5,
								border : 0
							} ]
						});
						this.callParent(arguments);
					},
					step : function(answer) {
						var me = this;
						var messageBox;
						var msgMultiApendix;
						var fStepperBound = function(answer) {
							me.step(answer);
						};
						var fNextStep = false;
						try {
    						var result = Ext.JSON.decode(answer);
    						if (result.result == null) {
    							this.end();
    						} else {
    							for ( var eIndex = 0; eIndex < result.result.events.length; eIndex++) {
    								var eItem = result.result.events[eIndex];
    								switch (eItem.properties.detail) {
    								case 'prepare':
    									this.iMaxStep = parseFloat(
    											eItem.properties.count, 10);
    									break;
    								case 'step':
    									var iStep=eItem.properties.index;
    									msgMultiApendix = Ext.String.format2(this.msgMultiApendix, {
                                            currentDevice : parseInt(eItem.properties.currentDevice,10) +1,
                                            maxNrOfDevice : parseInt(eItem.properties.maxNrOfDevices,10)});
    									if (iStep>this.iMaxStep)
    										iStep=this.iMaxStep;
    									this.progressBar.updateProgress(
    											(parseFloat(iStep, 10) + 1.0) / this.iMaxStep,
    											Ext.String.format2(this.msgStep, {
    												stepActual : parseFloat(
    														iStep,
    														10) + 1,
    												stepMaximal : this.iMaxStep
    											})  + msgMultiApendix, false);
    									break;
    								case 'complete':
    								    msgMultiApendix = Ext.String.format2(this.msgMultiApendix, {
                                            currentDevice : parseInt(eItem.properties.currentDevice,10) +1,
                                            maxNrOfDevice : parseInt(eItem.properties.maxNrOfDevices,10)});
    									if (eItem.properties.error=="true") {
    					        		    messageBox = Ext.create('Ext.window.MessageBox', {
    					        		    });
    					        		  	        			
    					        		    messageBox.show({
    							        	     title:_('Error'),
    							        	     msg: _('An Error has occured') + msgMultiApendix,
    							        	     buttons:Ext.MessageBox.OK,			        	    
    							        	     icon: Ext.Msg.WARNING 
    							        	});
    									}
    									
    									if (parseInt(eItem.properties.currentDevice, 10)+1  >= parseInt(eItem.properties.maxNrOfDevices,10)) {
    									    this.end();
    									}
    									break;
    								default : 
                                        messageBox = Ext.create('Ext.window.MessageBox', {
                                        });
                                                            
                                        messageBox.show({
                                             title:_('Error'),
                                             msg: _('An Error has occured'),
                                             buttons:Ext.MessageBox.OK,                         
                                             icon: Ext.Msg.WARNING 
                                        });
                                        this.end();
    								}
    							}						
    						}
						} catch (e) {
                            var messageBox = Ext.create('Ext.window.MessageBox', {
                            });
                                                
                            messageBox.show({
                                 title:_('Error'),
                                 msg: _('An Error has occured'),
                                 buttons:Ext.MessageBox.OK,                         
                                 icon: Ext.Msg.WARNING 
                            });
						    this.end(); 
						}
					},
					end : function() {
						this.hide();
						if (this.endCallback != null)
							this.endCallback();
					},
					start : function(paramForEvent, currentDevice, maxNrOfDevice) {
					    this.show();
						var me = this;
						fStepperBound = function(answer) {
							me.step(answer);
						};
						this.progressBar
								.updateProgress(0, this.msgStart, false);
                        dss.raiseEvent(me.eventNameStart, paramForEvent);
					}
				});